// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: list_service_publications_count_.sql

package queries

import (
	"context"
)

const listServicePublicationsCount = `-- name: ListServicePublicationsCount :one

SELECT
    count(*) total_count
FROM (
    SELECT service_name, content_hash, hash, directory_peer_id, null as delegator_peer_id
    FROM contracts.grants_service_publication
    WHERE service_peer_id = $1::text
    UNION DISTINCT
    SELECT service_name, content_hash, hash, directory_peer_id, delegator_peer_id
    FROM contracts.grants_delegated_service_publication
    WHERE service_peer_id = $1::text
) AS p
JOIN contracts.contracts_with_state AS c ON c.hash = p.content_hash
WHERE
    CASE
        when cardinality($2::text[]) = 0 THEN
            content_hash IN (SELECT hash AS content_hash FROM contracts.contracts_with_state)
        else
            content_hash IN (SELECT hash AS content_hash FROM contracts.contracts_with_state where contracts_with_state.state = ANY ($2::text[]))
        end
`

type ListServicePublicationsCountParams struct {
	SelfPeerID     string
	ContractStates []string
}

// Copyright © VNG Realisatie 2024
// Licensed under the EUPL
func (q *Queries) ListServicePublicationsCount(ctx context.Context, arg *ListServicePublicationsCountParams) (int64, error) {
	row := q.db.QueryRow(ctx, listServicePublicationsCount, arg.SelfPeerID, arg.ContractStates)
	var total_count int64
	err := row.Scan(&total_count)
	return total_count, err
}
